apiVersion: v1
kind: Service
metadata:
  name: rnkm-transit-service
  labels:
    domain: transit
    role: loadbalancer
spec:
  type: NodePort
  ports:
  - port: 80
    targetPort: 8080
    nodePort: 32101
    protocol: TCP
  selector:
    domain: transit
    role: loadbalancer
---
apiVersion: extensions/v1beta1
kind: Deployment
metadata:
  name: rnkm-transit-lb
spec:
  replicas: 1
  selector:
    matchLabels:
      domain: transit
      role: loadbalancer
  template:
    metadata:
      labels:
        domain: transit
        role: loadbalancer
      annotations:
        prometheus.io/scrape: 'true'
        prometheus.io/port: '8000'
    spec:
      imagePullSecrets:
      - name: regcred
      containers:
      - name: loadbalancer
        image: asia.gcr.io/rnkm-62-244919/transition-rnkm-loadbalancer:latest
        imagePullPolicy: Always
        livenessProbe:
          tcpSocket:
            port: 8080
          initialDelaySeconds: 5
          periodSeconds: 5
          timeoutSeconds: 3
        env:
          - name: LOADBALANCER_REDIS_HOST
            valueFrom:
              configMapKeyRef:
                name: datasource
                key: redisMaster
                optional: false

          - name: LOADBALANCER_MONGO_URL
            valueFrom:
              configMapKeyRef:
                name: datasource
                key: mongoURL
                optional: false

          - name: LOADBALANCER_KAFKA_BROKERS
            valueFrom:
              configMapKeyRef:
                name: message-broker
                key: kafka_broker
                optional: false

        resources:
          requests:
            cpu: "100m"
---
apiVersion: extensions/v1beta1
kind: Deployment
metadata:
  name: rnkm-transit-population
spec:
  replicas: 1
  selector:
    matchLabels:
      domain: transit
      role: population
  template:
    metadata:
      labels:
        domain: transit
        role: population
    spec:
      imagePullSecrets:
      - name: regcred
      containers:
      - name: population
        image: asia.gcr.io/rnkm-62-244919/transition-rnkm-population:latest
        imagePullPolicy: Always
        env:
          - name: POPULATION_REDIS_HOST
            valueFrom:
              configMapKeyRef:
                name: datasource
                key: redisMaster
                optional: false

          - name: POPULATION_KAFKA_BROKERS
            valueFrom:
              configMapKeyRef:
                name: message-broker
                key: kafka_broker
                optional: false

          - name: DEV
            value: "true"
        resources:
          requests:
            cpu: "50m"
---
apiVersion: extensions/v1beta1
kind: Deployment
metadata:
  name: rnkm-transit-teller
spec:
  replicas: 5
  selector:
    matchLabels:
      domain: transit
      role: teller
  template:
    metadata:
      labels:
        domain: transit
        role: teller
    spec:
      imagePullSecrets:
      - name: regcred
      containers:
      - name: teller
        image: asia.gcr.io/rnkm-62-244919/transition-rnkm-teller:latest
        imagePullPolicy: Always
        env:
          - name: TELLER_REDIS_HOST
            valueFrom:
              configMapKeyRef:
                name: datasource
                key: redisMaster
                optional: false

          - name: TELLER_KAFKA_BROKERS
            valueFrom:
              configMapKeyRef:
                name: message-broker
                key: kafka_broker
                optional: false

        resources:
          requests:
            cpu: "50m"
---
apiVersion: extensions/v1beta1
kind: Deployment
metadata:
  name: rnkm-transit-logger
spec:
  replicas: 1
  selector:
    matchLabels:
      domain: transit
      role: logger
  template:
    metadata:
      labels:
        domain: transit
        role: logger
    spec:
      imagePullSecrets:
      - name: regcred
      containers:
      - name: logger
        image: asia.gcr.io/rnkm-62-244919/transition-rnkm-logger:latest
        imagePullPolicy: Always
        env:
          - name: INFLUXHOST
            value: influx-influxdb

          - name: KAFKA_BROKERS
            valueFrom:
              configMapKeyRef:
                name: message-broker
                key: kafka_broker
                optional: false

          - name: KAFKA_CONSUMER_GROUPID
            value: logger

        resources:
          requests:
            cpu: "100m"
